unit ldn191u1;

// ADD "edit on enter"?


//SaveStringGrid NEEDS variable names tidied, and needs
//re-writing for other reasons, too.

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids,ClipBrd;

const vers='29 Sep 16';
   //started 26 Sep 16, on road to an application to
   //   vett DVD records data
   kGridMaxXIndex=15;
   kGridMaxYIndex=25;

   //Determines color scheme for the contents of the cells in the grid...
   //    FG / BG: The color of the text (ForeGround) /
   //               the color of the BackGround
   //    ok/ bad: Data in the cell OK (valid) or not (BAD)
   kClBGok=clWhite;
   kClFGok=clGreen;
   kClBGbad=clRed;
   kClFGbad=clBlack;

type

  { Tldn191f1 }

  Tldn191f1 = class(TForm)
    buQuit: TButton;
    buLoad: TButton;
    buSaveWithNewName: TButton;
    buResizeCols: TButton;
    buAbout: TButton;
    buLinkToWebClick: TButton;
    sgData: TStringGrid;
    procedure buAboutClick(Sender: TObject);
    procedure buLoadClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure buResizeColsClick(Sender: TObject);
    procedure buSaveWithNewNameClick(Sender: TObject);
    procedure buLinkToWebClickClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sgDataDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure sgDataSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: string);

  private
    { private declarations }
    clFgG,clBgG:array [0..kGridMaxXIndex,0..kGridMAxYIndex] of TColor;
    bLengthLimitInTestedColumn,bLengthTestedInWhichCol,
      bInListTestedColumn:byte;
    procedure SaveStringGrid(sFilename:string);
    procedure LoadFileToStringGrid(sFileName:string);
    procedure CheckDataLength(bCol,bLen:byte);
    procedure SetCellFgBg(iCol,iRow:integer;clFg,clBg:TColor);
    procedure CheckOneCellDataLength(bLen,bCol:byte;iRow:integer);
    procedure CheckDataInList(bCol:byte);
    procedure CheckOneCellDataInList(bCol:byte;iRow:integer);
    procedure StringToSGRow(sgLocal:TStringGrid;
                             sRawData:string;iRow:integer;boTrimFields:boolean);
  public
    { public declarations }
  end;

var
  ldn191f1: Tldn191f1;

implementation

{$R *.lfm}
{$R+}
// {$R+} turns on range-checking.

{ Tldn191f1 }

procedure Tldn191f1.FormCreate(Sender: TObject);
var bLoopCountL,bLoopCountL2:byte;
begin
  ldn191f1.caption:='LDN191- Use StringGrid to vett data- ver: '+vers;
  application.title:='LDN191';
  for bLoopCountL:= 0 to kGridMaxXIndex do
   for bLoopCountL2:= 0 to kGridMaxYIndex do begin
     clFgG[bLoopCountL,bLoopCountL2]:=kClFGok;
     clBgG[bLoopCountL,bLoopCountL2]:=kClBGok;
   end;//for bLoopCountL2
  //(the first "for" needs no end, as it had no begin)

  bLengthTestedInWhichCol:=2;//WHERE the data to be
    //checked for length resides.
  bLengthLimitInTestedColumn:=10;//HOW LONG a datum may
    //be, without being considered unacceptable.
  bInListTestedColumn:=1;//WHERE the data to be checked
    //for being in the list of acceptable values resides.

end;

procedure Tldn191f1.SaveStringGrid(sFilename:string);
//Doing it this way causes quotation marks to be inserted
//  around fields with spaces in them... which will cause
//  problems if the CSV is subsequently re-loaded
//  into this app. Re-write. Sigh.
var
  I: Integer;
  CSV: TStrings;
begin
  CSV := TStringList.Create;
  try
    for I := 1 to sgData.RowCount do
    begin
      CSV.Add(sgData.Rows[I-1].CommaText);//Probably only this needs re-writing
    end;
    CSV.SaveToFile(sFilename);
  finally
    CSV.Free;
  end;
showmessage('CSV re-saved, to '+sFilename+'. (If a '+
   'file of that name existed previously, it was '+
   'over-written.');
end;//SaveStringGrid

procedure Tldn191f1.buLoadClick(Sender: TObject);
begin
LoadFileToStringGrid('TestDataLDN191.txt');
sgData.AutoSizeColumns;
CheckDataLength(bLengthTestedInWhichCol,bLengthLimitInTestedColumn);
CheckDataInList(bInListTestedColumn);
end;

procedure Tldn191f1.buAboutClick(Sender: TObject);
begin
  showmessage('This is one of many applications '+
    'available from http://SheepdogGuides.com/Lut/'+chr(13)+
    '... a collection of Lazarsus and Delphi tutorials.');
end;

procedure Tldn191f1.sgDataDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
//Thanks to http://www.festra.com/wwwboard/messages/12892.html
//  for the information used to implement this approach to coloring
//  a cell in my StringGrid.
var sTmpL:string;
  clFgPrev,clBgPrev:TColor;
begin
  //Take a note of what is in the cell at the moment...
  sTmpL:=sgData.Cells[aCol,aRow];//Yes... we do need this and the
   //".. TextOut..." line below... both here AND in SetCellFgBg

  //Paint the the "paper" to establish background color...
  sgData.canvas.brush.color:=clBgG[aCol,aRow];
  sgData.canvas.FillRect(aRect);
  sgData.canvas.font.color:=clFgG[aCol,aRow];
  sgData.canvas.TextOut(aRect.Left + 2, aRect.Top + 2,sTmpL);//See
    //note on "sTmpL:=sgData...." line above.
end;//sgDataDrawCell

procedure Tldn191f1.SetCellFgBg(iCol,iRow:integer;clFg,clBg:TColor);
//There has GOT to be a better way. In particular, I don't like the
//  globals clFgG and clBgG... but this WORKS, and is the best I
//  can manage for the moment.
//N.B. This depends for it's functioning upon the DrawCell event
//  handler "sgDataDrawCell".
var sTmpL:string;
begin
 sTmpL:=sgData.Cells[iCol,iRow];//Yes... we do need this and the
   //"sgData.Cells[iCol,iRow]:=sTmpL;" line below...
   //both here and in DrawCell
 clFgG[iCol,iRow]:=clFg;
 clBgG[iCol,iRow]:=clBg;
 sgData.Cells[iCol,iRow]:=sTmpL;//See note on...
   //sTmpL:=sgData.Cells[iCol,iRow]; line
 end;//SetCellFgBg

procedure Tldn191f1.CheckDataLength(bCol,bLen:byte);
var iLoopCounterCDL:integer;
begin
 for iLoopCounterCDL:=0 to sgData.RowCount-1 do
   CheckOneCellDataLength(bLen,bCol,iLoopCounterCDL);
end;//CheckDataLength

procedure Tldn191f1.CheckDataInList(bCol:byte);
var iLoopCounterCDL:integer;
begin
 for iLoopCounterCDL:=0 to sgData.RowCount-1 do
   CheckOneCellDataInList(bCol,iLoopCounterCDL);
end;//CheckDataInList

procedure Tldn191f1.CheckOneCellDataInList(bCol:byte;iRow:integer);
//"Bad Programming": Makes direct access to a global
//object, the StringGrid sgData. I am comfortable
//that in this case, "the rule" has been broken for
//sensible reasons, and in a manner which is not
//likely to be regretted.
var boTmpL:boolean;
  sTmpL:string;
begin
  boTmpL:=false;//Start with idea that datum is NOT valid.
  sTmpL:=sgData.Cells[bCol,iRow];
  if sTmpL='MA' then boTmpL:=true;
  if sTmpL='CA' then boTmpL:=true;
  if sTmpL='NY' then boTmpL:=true;
  //Etc. As many "if sTmpL='....' then boTmpL:=true;"
  //  as you wish, and then....

  if boTmpL=false then
    SetCellFgBg(bCol,iRow,kClFGbad,kClBGbad)//no ; here
  else
    SetCellFgBg(bCol,iRow,kClFGok,kClBGok);//no "end" here. End of "else"
end;//CheckOneCellDataInList

procedure Tldn191f1.CheckOneCellDataLength(bLen,bCol:byte;iRow:integer);
//"Bad Programming": Makes direct access to a global
//object, the StringGrid sgData. I am comfortable
//that in this case, "the rule" has been broken for
//sensible reasons, and in a manner which is not
//likely to be regretted.
begin
  if length(sgData.Cells[bCol,iRow])>bLen then
    SetCellFgBg(bCol,iRow,kClFGbad,kClBGbad)//no ; here
  else
    SetCellFgBg(bCol,iRow,kClFGok,kClBGok);//no "end" here. End of "else"
end;//CheckOneCellDataLength

procedure Tldn191f1.sgDataSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: string);
//This is called every time a character is changed in a cell.
//Maybe there's another event for "leaving cell, editing done"... but
//  I don't think the overheads of checking as we go along are
//  too terrible. Maybe during the load-whole-grid process they
//  will be insupportable, when more columns are being tested.
begin
 //showmessage('hi.. col/row: '+inttostr(acol)+'  '+inttostr(aRow));
  if aCol=bLengthTestedInWhichCol then
       CheckOneCellDataLength(bLengthLimitInTestedColumn,aCol,aRow);
  if aCol=bInListTestedColumn then
       CheckOneCellDataInList(aCol,aRow);
  //You COULD have one of these here: sgData.AutoSizeColumns;
  //... but that would result in columns frequently re-sizing
  //    as the user entered data.... and as the program loaded
  //    the grid in the first place from the CSV file. Probably
  //    not the way to go.
end;

procedure Tldn191f1.LoadFileToStringGrid(sFileName:string);
(*The file to be loaded should consist of one or more
  RECORDS, each consisting of one or more FIELDS.
  The file should consist printable characters, plus
  (maybe) the code for TAB, and a FEW others like that.
  The RECORDS are separated by CR/LF terminators,
  FIELDS are separated by COMMAS. A line ending in
  a comma is considered to indicate that the final
  field of that record had nothing in it, e.g.....
    Three fields: Fred,Bloggs,860-767-5555
    Four fields: Fred,Bloggs,860-767-5555,

  ---
  See http://sheepdogguides.com/lut/lt4Nd.htm
  for details of how this part of the application
  works.
  *)

var
  cardCounter:Cardinal;
  stringsTmp:TStrings;
begin //LoadFileToStringGrid
  stringsTmp:=TStringList.Create;
  try
    stringsTmp.LoadFromFile(sFileName);
    sgData.RowCount:=stringsTmp.Count;//Yes: .count, not .count-1
    sgData.ColCount:=7;//This CLUMSY... But could fairly easily
      //be replaced by code to count the fields in the first
      //line, and make the StringGrid have that many columns.
      //The "built in" LoadFromCSVFile does that. Both routines
      //ignore the fact that a data file might have more
      //fields in a subsequent record. (The extra fields are
      //just thrown away in the LoadFromCSVFile. At present,
      //they cause a problem (good! You'll know about them!)
      //in this answer. (That can be fixed.)
      //What's done here, for the moment, is to set, by hand, something
      //that limits how many fields there can be in any record
      //in the CSV file. Exceed that limit, and the application
      //shuts down, in a messy way. Fall short of that on a given
      //line, and you just have some empty cells at the right hand
      //end of the line.

      //For the future: Add a parameter to LoadFileToStringGrid
      //If zero: Use the "answer" used by LoadFromCSVFile, if
      //> zero, set ColCount from that. (If this is done, also
      //provide a "scan file, find out longest (most fields) record"
      //function.)
      //
      //In any case, add a "var" variable to return error codes
      //to user.... "file not found","too many fields encountered",
      //etc.

      //Also add a parameter to specify the separator character.
      //Add a way to use....  "Bloggs, Fred",123 to allow separator
      //  character inside a field? Make it optional, and tell
      //users that the application runs faster if they don't
      //use the feature?

    for cardCounter:= 0 to stringsTmp.Count-1 do begin
          StringToSGRow(sgData,stringsTmp[cardCounter],cardCounter,true);
          end;

      //To be checked... what does app do when a)there is / b) there
      //  is not a CR at the end of the file? (Prelim checks: It doesn't
      //  matter.  (^_^)
      //If there is a last line consisting just of spaces, the Lazarus
      //  version does NOT add a row to the StringGrid, the
      //  SheepdogGuides version DOES add a row

  finally
    stringsTmp.Free;
    end;//Try... finally

  //Put....  sgData.AutoSizeColumns;
  //   ... in your code, after the call of LoadFileToStringGrid,
  //   if you would like all of the columns' widths adjusted,
  //   leaving each column just wide enough for the widest datum
  //   in the column.

end;//LoadFileToStringGrid

procedure Tldn191f1.StringToSGRow(sgLocal:TStringGrid;
                             sRawData:string;iRow:integer;boTrimFields:boolean);
var bColIndexL:byte;
  sOneField:string;
  boDoneIt:boolean;
//This procedure is used within "LoadFileToStringGrid". You
//  wouldn't be likely to want to call it directly.

//Takes, from sRawData, a string like...
//  860-555-1912,CT,Joe Smith
//... and puts the three fields in the first three
//colums of StringGrid sgLocal.
//What's in sRawData is "eaten away" over the course of the procedure.
//If boTrimFields is true, then spaces at either end of the field datum
//  are trimmed off....
//  "   sample datum   "
//  ... would become...
//  "sample datum"

  function boChomp(var sSource:string;
        var sDest:string):boolean;//SR of StringToSGRow
  //N.B. BOTH PARAMS ARE *var* PARAMS... contents of the
  //variables used to "feed" this SR will be changed by
  //the execution of the procedure.
  //
  //The contents of sDest before the call are irrelevant.
  //
  //If the string passed to sSource has a comma at it's
  //  right hand end, then the routine assumes that to mean
  //  that there is a field after the comma, but that the
  //  contents of that field just happen to be "nothing",
  //  i.e. ''. In the processing of such a string, sSource
  //  will be passed back to the calling program with a
  //  rogue value, just before the call of Chomp which
  //  "reads" the "empty" field.
  //In other words... string "a" has three fields,
  //  string "b" has FOUR...
  //     a) Fred,Bloggs,860-767-5555
  //     b) Fred,Bloggs,860-767-5555,
  //                             ---^---
  var iPosOfComma:integer;
  const kFieldSep=',';//Rewrite to supply this in
     //a parameter, if you feel having that
     //flexiblity is important to you.

  begin //main block of boChomp, SR of StringToSGRow
    if sSource='' then result:=true//no ; here
         //(See "N.B. bChomp returns...", below. THIS "true"
         //arises if you call Chomp when there was no point...
         //you already knew there was no more data to parse.
    else begin //1  (Use last field in string that started
         //String1, String2, .... , StringLast
      //(There will be no comma after last field.)

      //N.B. boChomp returns false until there is no more
      //  data to be harvested by a further call of Chomp.
      //Note especially... the first time it
      //  returns TRUE, there is STILL one field to be
      //  USED by the calling program. It has been
      //  returned to the calling program in sDest,
      //  as usual.

      if sSource='tkbRogueToIndicateNullFieldAtEndOfRaw' then
            sSource:='';
      iPosOfComma:=pos(kFieldSep,sSource);
      if iPosOfComma=0 then begin //2
           //The "=1" case arises if the string you are
           //chomping ends with a comma, which is interpreted
           //as meaning that there IS one more field in the
           //string, but it just happens to consist of nothing,
           //just happens to be ''}
        sDest:=sSource;
        sSource:='';
        result:=true;//(See "N.B. bChomp returns..." THIS "true"
          //is for the case where you have just harvested the last
          //field from the string you have been "chomping" through.
        end//no ; here. End of "then 2"
      else begin //2
          if iPosOfComma=length(sSource) then
               sSource:=sSource+'tkbRogueToIndicateNullFieldAtEndOfRaw';
          sDest:=copy(sSource,1,iPosOfComma-1);
          sSource:=copy(sSource,iPosOfComma+1,length(sSource));
          result:=false;
          end;//of "else 2"
        end;// of "else 1"
  end;//boChomp, SR of StringToSGRow

begin //main block of StringToSGRow
   bColIndexL:=0;
   boDoneIt:=false;
   repeat
     boDoneIt:=boChomp(sRawData,sOneField);//N.B: These are "var"
          //parameters. A bit is chopped off of sRawData, and
          //sOneField is filled with a new value. Also: You can
          //ignore compiler warning about sOneField not being
          //initialized.
     if boTrimfields then sOneField:=trim(sOneField);

     //If you want to "see something" when a field in the
     //  CSV says "nothing, here", de-rem the following...
     //if sOneField='' then sOneField:='null';
     sgLocal.cells[bColIndexL,iRow]:=sOneField;

     inc(bColIndexL);

   until (boDoneIt) OR (bColIndexL>8);//second term to be refined in
     //due course... at present, it is a kludge... but it WILL have
     //a role to play one day. Keep note at top of code in step.
     //(Eventually, before LoadFileToStringGrid,
     //is called, somehow a determination will be made as to how many
     //columns are to be filled. If, by chance or error, the CSV file
     //has a record with too many fields, at the moment problems arise.
     //When the "8" is replaced by a variable, and that is loaded to
     //reflect how big the StringGrid available is, then steps can be
     //taken to deal nicely with a "too big for the row" record from
     //the CSV file.
end;//StringToSGRow

procedure Tldn191f1.buResizeColsClick(Sender: TObject);
begin
  showmessage('Currently a work in progress. Not central to application.');
  sgData.AutoSizeColumns;
  //Next line: Crude, and not discussed in turtorial... but "works"
  //  to make width of stringgrid right for columns on it.
  //Doing same for height possible, more tedious.
  //The code for both needs to be in a better place, too... this
  //  just shows how it could be done.
  //NEEDS WORK...
     //sgData.width:=sgData.ColWidths[0]+sgData.ColWidths[1]+sgData.ColWidths[2];
end;

procedure Tldn191f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure Tldn191f1.buSaveWithNewNameClick(Sender: TObject);
begin
   SaveStringGrid('TmpLDN191SavedFile.txt');
end;

procedure Tldn191f1.buLinkToWebClickClick(Sender: TObject);
begin
  Clipboard.AsText:='http://sheepdogguides.com/lut/lt4Nc.htm';
end;


end.

